Subject: Re: bug#16407: Info-directory-list should always put this Emacs's info direc first

From: Eli Zaretskii <[email-masked]>
Date: Fri, 10 Jan 2014 10:19:18 +0200

> From: Glenn Morris <[email-masked]>
> Cc: [email-masked]
> Date: Fri, 10 Jan 2014 02:38:56 -0500
> 
> Eli Zaretskii wrote:
> 
> > That leaves system administrators no means of forcing a specific
> > version of Info manual to be found by default.
> 
> That is true, it does not, but only for manuals that come with Emacs.

They are a plenty.

> I cannot think of a case where a *sysadmin* would want to force
> Emacs to prefer some other version of a manual to the one that comes
> with Emacs.  Can you give an example?

On a multi-user system, INFOPATH can be customized differently for
each user, but /usr/share/info is a single directory.  Suppose some
users want to stay with an older Emacs, while others want the bleeding
edge.

> (And they could always do it with some site-specific elisp if they
> really wanted to. But I expect it to be very much a fringe case.)

Experience has taught us that there are too many "fringe cases" when
Info docs are concerned.  The code to which you pointed was a result
of prolonged discussions in the past, and many micro-corrections due
to these fringe cases.  Eventually, some of the use cases stay
unsupported, and AFAIR cannot be supported without hurting no less
important cases, because Info simply is not designed for there being
several manuals by the same name on INFOPATH.

> By default, Emacs uses the Gnus that comes with Emacs.
> To get it to use a different Gnus, you have to customize load-path.
> I do not think it unreasonable that you should have to similarly
> customize Info-directory-list to get the right manual.

The question is not what's reasonable.  The question is do people (or
"make install" of those packages) actually do that.

> > Is this the only situation where the current arrangement doesn't DTRT,
> > or are there more?  If this is the only one, then you cannot solve it
> > successfully: the Info system simply doesn't support well the use case
> > where several different manuals have identical names.
> 
> I don't understand why it cannot be solved successfully by doing what I
> said. I don't care about seeing multiple versions of the manuals with
> the same name, I want to see only one version, and I want that version
> to be the version that comes with Emacs.

Again, since Emacs, like every other package, installs its Info files
in a single global directory, you don't actually know what is "the
version that comes with Emacs", except when Emacs runs uninstalled (in
which case it already does what you want).  All you know is that
there's some FOO.info file in /usr/share/info.  If it is overwritten,
you don't know that.  So this problem is in general unsolvable.

> And note that the Mac platform has already behaved as I request for some
> years. I don't recall seeing any complaints.

This goes both ways: I don't recall complaints about the current
arrangement, either.